#################################################################################################################################
#Выгрузка для сайта Стандарт-М 987439 08-04-2021 А.К. ТЗ во вложении к заявке
#################################################################################################################################

#C:\Users\Standart\PycharmProjects\pythonProject\venv\Scripts\pip install pycurl
import declare
import fdb
import lan_fdb
import json
from ftplib import FTP
import zipfile
import os
import requests
import sys
import pycurl
import logging
import time

def LogIt(text,status=None):
    with open(declare.dir+'log.txt', 'a')as log:
        log_string = time.strftime("%d.%m.%y %H:%M:%S")
        log_string = log_string +' '+ text + "\n"
        log.write(log_string)
    print(log_string)

LogIt("Начало выгрузки")

# init connect to database
conn = fdb.connect(host=declare.host, database=declare.db_file, user='sysdba', password='masterkey')
curs = conn.cursor()

#################################################################################################################################
#1 stores - выгрузка справочника аптек
LogIt("1 stores - выгрузка справочника аптек")
#store_id | guid
#name | string
#address | string
#phone | string
#work_hours | string
#lat | double
#lon | double
#legal_name | string
#legal_id | string (ОГРН, ОГРНИП)

sql = "select id," \
      "caption as name," \
      "(select param_value from params p where p.g$profile_id=g.id and p.param_id = 'ORG_ADRESS' ) as address," \
      "(select param_value from params p where p.g$profile_id=g.id and p.param_id = 'ORG_PHONE' ) as phone " \
      "from G$PROFILES g where dbsecurekey is not null and relationtype=1 and dbsecurekey not containing '!' and id <> 100"


result = lan_fdb.get_sql(curs, sql)
res=[]
for line in result:
    res.append({"id":line[0],"name":line[1],"address":line[2],"phone":line[3]})
#print(res)

filename =declare.dir+"stores.json"
with open(filename, 'w', encoding='cp1251') as f:
     json.dump(res, f, ensure_ascii=False, indent=4)

#################################################################################################################################
LogIt("2 catalog - выгрузка справочника товаров СЛС, которые привязаны к справочнику номенклатуры")
#2 catalog - выгрузка справочника товаров СЛС, которые привязаны к справочнику номенклатуры
#catalog_id | guid
#name | string
#synonyms | array of strings - синонимы к названию лекарства
#group | array of int (не используется) - группы
#n1 | string - состав
#n2 | string - действие
#n3 | string - побочное действие
#n4 | string - взаимодействие
#n5 | string - показания к применению
#n6 | string - противопоказания
#n7 | string - применение
#n8 | string - лекарственные формы
#n9 | string - условия хранения
#n10 | image_id (guid) - фото
#n11 | string - производители
#n12 | int (не используется) - фармгруппа
#n13 | string - международное непатентованное наименование
#n14 | string - передозировка
#n15 | string - особые указания
#n16 | string - фармокинетика
#ndx1 | string - показания к применению
#ndx2 | string - действие

sql = "select CID, PNAME, SYNONIM, GROUP_ID, N1,N2,N3,N4,N5,N6,N7,N8,N9,N10,N11,N12,N13,N14,N15,N16,NDX1,NDX2 from site_source ss where "\
                    " exists(select cid from site_wares_source sws where sws.cid = ss.cid)"


result = lan_fdb.get_sql(curs, sql)
res=[]
for line in result:
    res.append({"catalog_id":line[0],"name":line[1],"synonyms":line[2],"group":line[3],"n1":line[4],"n2":line[5],"n3":line[6],"n4":line[7],"n5":line[8],"n6":line[9],"n7":line[10],"n8":line[11],"n9":line[12],"n10":line[13],"n11":line[14],"n12":line[15],"n13":line[16],"n14":line[17],"n15":line[18],"n16":line[19],"ndx1":line[20],"ndx2":line[21]})
#print(res)

filename =declare.dir+"catalog.json"
with open(filename, 'w', encoding='cp1251') as f:
     json.dump(res, f, ensure_ascii=False, indent=4)

#################################################################################################################################
#3 nomenclature - выгрузка текущих остатков
LogIt("3 nomenclature - выгрузка текущих остатков")
#/api/v1/nomenclature - справочник товаров
#0 nomenclature_id | guid
#1 catalog_id | guid
#2 barcode | string
#3 manufacturer | string
#4 country | string
#5 price | double
#6 expiration_date | date
#7 group_id | array of int
#8 sname | string

sql = "select ware_id as nomenclature_id,"\
      "(select s.cid from site_wares_source s where s.ware_id = w.ware_id) as  catalog_id,"\
      "bcode_izg as barcode,"\
      "sizg as manufacturer,"\
      "scountry as country, "\
      "round(avg(w.price),2) as price,"\
      "max(cast(cast(godendo as dm_date) as dm_text)) as expiration_date,"\
      "(select list(distinct gd.group_id) from group_detail gd left join groups g on g.id = gd.group_id and g.grouptable=gd.grouptable "\
      "   where gd.grouptable_id = cast(w.name_id as dm_text) and gd.grouptable='PARTS.NAME_ID' and (g.parent_id =2073 or ((select first 1 g2.parent_id from groups g2 where g2.id = g.parent_id) = 2073)) ) as group_id,"\
      "sname "\
      " from warebase_g w where sname is not null and quant > 0 "\
      "  group by  sname, sizg, scountry, bcode_izg, ware_id, name_id";

result = lan_fdb.get_sql(curs, sql)
res=[]
for line in result:
    res.append({"nomenclature_id":line[0],"catalog_id":line[1],"barcode":line[2],"manufacturer":line[3],"country":line[4],"price":line[5],"expiration_date":line[6],"group_id":line[7],"sname":line[8]})
#print(res)

filename =declare.dir+"nomenclature.json"
with open(filename, 'w', encoding='cp1251') as f:
     json.dump(res, f, ensure_ascii=False, indent=4)

#################################################################################################################################
#4 quantities - складские остатки
LogIt("4 quantities - складские остатки")

#0 nomenclature_id | guid
#1 store_id | guid
#2 amount | int

sql = "select nomenclature_id, store_id, amount from "\
      "  (select ware_id as nomenclature_id,"\
      "          round(sum(quant),0) as amount,"\
      "           w.g$profile_id as store_id "\
      "   from warebase_g w where sname is not null and quant > 0 "\
      "   group by  ware_id, w.g$profile_id "\
      ") where  amount > 0";

result = lan_fdb.get_sql(curs, sql)
res=[]
for line in result:
    res.append({"nomenclature_id":line[0],"store_id":line[1],"amount":line[2]})
#print(res)

filename =declare.dir+"quantities.json"
with open(filename, 'w', encoding='cp1251') as f:
     json.dump(res, f, ensure_ascii=False, indent=4)


#################################################################################################################################
#Архивирование файлов
#################################################################################################################################
LogIt("Архивирование файлов")
zipFile = zipfile.ZipFile(declare.dir+'stores.zip', 'w', zipfile.ZIP_DEFLATED)
zipFile.write(declare.dir+'stores.json')
zipFile.close()

zipFile = zipfile.ZipFile(declare.dir+'nomenclature.zip', 'w', zipfile.ZIP_DEFLATED)
zipFile.write(declare.dir+'nomenclature.json')
zipFile.close()

zipFile = zipfile.ZipFile(declare.dir+'catalog.zip', 'w', zipfile.ZIP_DEFLATED)
zipFile.write(declare.dir+'catalog.json')
zipFile.close()

zipFile = zipfile.ZipFile(declare.dir+'quantities.zip', 'w', zipfile.ZIP_DEFLATED)
zipFile.write(declare.dir+'quantities.json')
zipFile.close()

#################################################################################################################################
#Выгрузка на API
#################################################################################################################################
LogIt("Выгрузка на API")
crl = pycurl.Curl()

crl.setopt(crl.URL, declare.url)
crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'stores.zip',crl.FORM_FILENAME, 'stores.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
crl.perform()
LogIt('stores.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))

crl.setopt(crl.URL, declare.url)
crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'nomenclature.zip',crl.FORM_FILENAME, 'nomenclature.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
crl.perform()
LogIt('nomenclature.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))

crl.setopt(crl.URL, declare.url)
crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'catalog.zip',crl.FORM_FILENAME, 'catalog.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
crl.perform()
LogIt('catalog.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))

crl.setopt(crl.URL, declare.url)
crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'quantities.zip',crl.FORM_FILENAME, 'quantities.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
crl.perform()
LogIt('quantities.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))


crl.close()
LogIt("Окончание выгрузки")

#ftp = FTP()
#ftp.connect('195.210.47.231', 21)
#ftp.login('admin_standart', 'ExHdGPXga4EZrGOE')
#ftp.set_pasv(True)
#ftp.storlines("STOR " + file_name, open(filename, 'rb'))
#ftp.quit()